/*
 * This file was generated by the MozButton SDK,
 * which is part of the Toolbar Buttons project.
 * You should not edit this file, but rather download
 * the project source and rerun the builder.
 */

const Cc = Components.classes;
const Ci = Components.interfaces;
const Cu = Components.utils;

Cu.import("resource://gre/modules/Services.jsm");
var styleSheets = [Services.io.newURI("chrome://tb-all-menus-toolbar-button/skin/button.css", null, null)];

var gModules = {};

function getModules(uri) {
	var modules = [];
	if(uri == 'chrome://messenger/content/messengercompose/messengercompose.xul') {
		modules.push('chrome://tb-all-menus-toolbar-button/content/compose.jsm');
	} else if(uri == 'chrome://navigator/content/navigator.xul') {
		modules.push('chrome://tb-all-menus-toolbar-button/content/suite_browser.jsm');
	} else if(uri == 'chrome://browser/content/browser.xul') {
		modules.push('chrome://tb-all-menus-toolbar-button/content/browser.jsm');
	} else if(uri == 'chrome://messenger/content/messageWindow.xul') {
		modules.push('chrome://tb-all-menus-toolbar-button/content/read.jsm');
	} else if(uri == 'chrome://calendar/content/calendar.xul') {
		modules.push('chrome://tb-all-menus-toolbar-button/content/calendar.jsm');
	} else if(uri == 'chrome://messenger/content/messenger.xul') {
		modules.push('chrome://tb-all-menus-toolbar-button/content/lightning.jsm');
		modules.push('chrome://tb-all-menus-toolbar-button/content/mail.jsm');
	} else if(uri == 'chrome://sunbird/content/calendar.xul') {
		modules.push('chrome://tb-all-menus-toolbar-button/content/calendar.jsm');
	}
	return modules;
}

function loadIntoWindow(window) {
	// kind of dumb using the document uri, but it makes coping from the chrome.manifest easier
	let uri = window.document.documentURI;
	let modules = getModules(uri);
	if(modules) {
		for (var i = 0, len = styleSheets.length; i < len; i++) {
			try {
				window.QueryInterface(Ci.nsIInterfaceRequestor)
					.getInterface(Ci.nsIDOMWindowUtils).loadSheet(styleSheets[i], Ci.nsIDOMWindowUtils.AUTHOR_SHEET);
			} catch(e) {
				// throws error is there had been an unclean shutdown and the sheet is still loaded
			}
		}
		for(var i = 0; i < modules.length; i++) {
			try {
				var modPath = modules[i];
				if(gModules[modPath]) {
					var mod = gModules[modPath];
				} else {
					var mod = Cu.import(modPath);
					mod.setupButtons();
					gModules[modPath] = mod;
				}
				mod.loadButtons(window);
			} catch(e) {
				window.console.log(e);
			}
		}
	}
	if(uri == 'chrome://global/content/customizeToolbar.xul') {
		for (var j = 0, len = styleSheets.length; j < len; j++) {
			window.QueryInterface(Ci.nsIInterfaceRequestor)
				.getInterface(Ci.nsIDOMWindowUtils).loadSheet(styleSheets[j], Ci.nsIDOMWindowUtils.AUTHOR_SHEET);
		}
	}
}

function unloadFromWindow(window) {
	let uri = window.document.documentURI;
	let modules = getModules(uri);
	if(modules) {
		for (let i = 0, len = styleSheets.length; i < len; i++) {
			window.QueryInterface(Ci.nsIInterfaceRequestor)
				.getInterface(Ci.nsIDOMWindowUtils).removeSheet(styleSheets[i], Ci.nsIDOMWindowUtils.AUTHOR_SHEET);
		}
		for(var i = 0; i < modules.length; i++) {
			try {
				var modPath = modules[i];
				if(gModules[modPath]) {
					var mod = gModules[modPath];
					mod.unloadButtons(window);
				}
			} catch(e) {
				window.console.log(e);
			}
		}
	}
	if(uri == 'chrome://global/content/customizeToolbar.xul') {
		for (var i = 0, len = styleSheets.length; i < len; i++) {
			window.QueryInterface(Ci.nsIInterfaceRequestor)
				.getInterface(Ci.nsIDOMWindowUtils).removeSheet(styleSheets[i], Ci.nsIDOMWindowUtils.AUTHOR_SHEET);
		}
	}
}

var windowListener = {
	onOpenWindow: function(aWindow) {
		// Wait for the window to finish loading
		let domWindow = aWindow.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindowInternal || Ci.nsIDOMWindow);
		domWindow.addEventListener("load", function onLoad() {
			domWindow.removeEventListener("load", onLoad, false);
			loadIntoWindow(domWindow);
		}, false);
	}, 
	onCloseWindow: function(aWindow) {},
	onWindowTitleChange: function(aWindow, aTitle) {}
};

function createResource(resourceName, uriPath) {
	let resource = Services.io.getProtocolHandler("resource").QueryInterface(Ci.nsIResProtocolHandler);
	var fileuri = Services.io.newURI(uriPath, null, null);
	resource.setSubstitution(resourceName, fileuri);
}

function startup(data, reason) {
	// set our default prefs
	try {
		Services.scriptloader.loadSubScript("chrome://tb-all-menus-toolbar-button/content/defaultprefs.js", {pref: setDefaultPref});
	} catch(e) {}
	
	

	let wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);

	// Load into any existing windows
	let windows = wm.getEnumerator(null);
	while (windows.hasMoreElements()) {
		let domWindow = windows.getNext().QueryInterface(Ci.nsIDOMWindow);
		loadIntoWindow(domWindow);
	}
	// Load into any new windows
	wm.addListener(windowListener);
}

function shutdown(data, reason) {
	if (reason == APP_SHUTDOWN) {
		return;
	}

	let resource = Services.io.getProtocolHandler("resource").QueryInterface(Ci.nsIResProtocolHandler);
	resource.setSubstitution("tb-all-menus-toolbar-button", null);

	let wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
 
	// Stop listening for new windows
	wm.removeListener(windowListener);

	// Unload from any existing windows
	let windows = wm.getEnumerator(null);
	while (windows.hasMoreElements()) {
		try {
			let domWindow = windows.getNext().QueryInterface(Ci.nsIDOMWindow);
			unloadFromWindow(domWindow);
		} catch(e) {
			log(e);
		}
	}
	// destroy the modules
	for(var modPath in gModules) {
		try {
			var mod = gModules[modPath];
			mod.shutdownButtons();
			Cu.unload(modPath);
		} catch(e) {
			log(e);
		}
	}
	gModules = {};
	Cu.unload("chrome://tb-all-menus-toolbar-button/content/customizable.jsm");
}

function install(data, reason) {

}

function uninstall(data, reason) {
}

function log(e) {
	Cc["@mozilla.org/consoleservice;1"].getService(Ci.nsIConsoleService).logStringMessage(e);
}

function getGenericPref(branch, prefName) {
	switch (branch.getPrefType(prefName)) {
		default:
		case 0:   return undefined;					  // PREF_INVALID
		case 32:  return getUCharPref(prefName,branch);  // PREF_STRING
		case 64:  return branch.getIntPref(prefName);	// PREF_INT
		case 128: return branch.getBoolPref(prefName);   // PREF_BOOL
	}
}

function setGenericPref(branch, prefName, prefValue) {
	switch (typeof prefValue) {
		case "string":
			setUCharPref(prefName, prefValue, branch);
			return;
		case "number":
			branch.setIntPref(prefName, prefValue);
			return;
		case "boolean":
			branch.setBoolPref(prefName, prefValue);
			return;
	}
}

function setDefaultPref(prefName, prefValue) {
	var defaultBranch = Services.prefs.getDefaultBranch(null);
	setGenericPref(defaultBranch ,prefName, prefValue);
}

function getUCharPref(prefName, branch) {
	branch = branch ? branch : Services.prefs;
	return branch.getComplexValue(prefName, Ci.nsISupportsString).data;
}

function setUCharPref(prefName, text, branch) {
	var string = Cc["@mozilla.org/supports-string;1"].createInstance(Ci.nsISupportsString);
	string.data = text;
	branch = branch ? branch : Services.prefs;
	branch.setComplexValue(prefName, Ci.nsISupportsString, string);
}
