/*
 * This file was generated by the MozButton SDK,
 * which is part of the Toolbar Buttons project.
 * You should not edit this file, but rather download
 * the project source and rerun the builder.
 */

const Cc = Components.classes;
const Ci = Components.interfaces;
const Cu = Components.utils;

var EXPORTED_SYMBOLS = ["loadButtons", "unloadButtons", "setupButtons", "shutdownButtons"];

try {
	Cu.import("resource:///modules/CustomizableUI.jsm");
} catch(e) {
	Cu.import("chrome://tb-all-menus-toolbar-button/content/customizable.jsm");
}

Cu.import('resource://gre/modules/Services.jsm');
Cu.import("resource://services-common/stringbundle.js");



var gShutDownFunctions = [];

var toolbar_buttons = {
	interfaces: {},
	// the important global objects used by the extension
	toolbar_button_loader: function(parent, child) {
		var object_name;
		for(object_name in child){
			if(object_name == 'interfaces') {
				toolbar_buttons.toolbar_button_loader(parent.interfaces, child.interfaces);
			} else {
				parent[object_name] = child[object_name];
			}
		}
	},
	registerCleanUpFunction: function(func) {
		gShutDownFunctions.push(func);
	}

};
var loader = Cc["@mozilla.org/moz/jssubscript-loader;1"].getService(Ci.mozIJSSubScriptLoader);
var gScope = this;
// the number at the end forces a reload of the properties file, since sometimes it it catched when we don't want
var buttonStrings = new StringBundle("chrome://tb-all-menus-toolbar-button/locale/tb-all-menus_button_labels.properties?time=" + Date.now().toString());

function setupButtons() {
	var extensionPrefs = Cc['@mozilla.org/preferences-service;1'].getService(Ci.nsIPrefService).getBranch("extension.tbutton.");
	loader.loadSubScript("chrome://tb-all-menus-toolbar-button/content/button.js", gScope);
		CustomizableUI.createWidget({
		id: 'tb-help-menu',
		label: buttonStrings.get('tb-help-menu.label'),
		tooltiptext: buttonStrings.get('tb-help-menu.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.showAMenu(event, 'helpMenu', 'menu_Help');
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-file-menu',
		label: buttonStrings.get('tb-file-menu.label'),
		tooltiptext: buttonStrings.get('tb-file-menu.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.showAMenu(event, 'menu_File', 'file-menu');
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-format-menu',
		label: buttonStrings.get('tb-format-menu.label'),
		tooltiptext: buttonStrings.get('tb-format-menu.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.showAMenu(event, 'formatMenu');
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-tools-menu',
		label: buttonStrings.get('tb-tools-menu.label'),
		tooltiptext: buttonStrings.get('tb-tools-menu.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.showAMenu(event, 'tasksMenu', 'menu_Tools', 'tools-menu');
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-all-menus',
		defaultArea: 'composeToolbar2',
		type: 'custom',
		label: buttonStrings.get('tb-all-menus.label'),
		tooltiptext: buttonStrings.get('tb-all-menus.tooltip'),
		toolbox: 'compose-toolbox',
		onCreated: function(aNode){
			var document = aNode.ownerDocument;
			toolbar_buttons.allMenusStartUp(document);
		},
		onBuild: function (document) {
			var window = document.defaultView;
			var popupset = document.getElementById('PanelUI-multiView');
			if(popupset) {
				var menupopup_1 = document.createElement('panelview');
				menupopup_1.id = 'tb-all-menus-popup';
				menupopup_1.addEventListener('command', function(event) {
				event.stopPropagation();
			}, false);
				menupopup_1.addEventListener('popupshowing', function(event) {
				var aThis = event.currentTarget;
			toolbar_buttons.loadAllMenusMenu(aThis, event);
			}, false);
				menupopup_1.addEventListener('popuphidden', function(event) {
				var aThis = event.currentTarget;
			toolbar_buttons.allMenusReturnPopups(aThis, event);
			}, false);
				popupset.appendChild(menupopup_1);
				menupopup_1.id = "tb-all-menus-panel-view";
			}
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'tb-all-menus';
			toolbarbutton_0.setAttribute("type", "menu");
			toolbarbutton_0.setAttribute('label', buttonStrings.get('tb-all-menus.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('tb-all-menus.tooltip'));
			toolbarbutton_0.addEventListener('click', function(event) {
				var aThis = event.currentTarget;
			toolbar_buttons.allMenuOpen(aThis, event);
			}, false);
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			toolbarbutton_0.setAttribute("usepanelview", "menu");
			var menupopup_1 = document.createElement('menupopup');
			menupopup_1.id = 'tb-all-menus-popup';
			menupopup_1.addEventListener('command', function(event) {
				event.stopPropagation();
			}, false);
			menupopup_1.addEventListener('popupshowing', function(event) {
				var aThis = event.currentTarget;
			toolbar_buttons.loadAllMenusMenu(aThis, event);
			}, false);
			menupopup_1.addEventListener('popuphidden', function(event) {
				var aThis = event.currentTarget;
			toolbar_buttons.allMenusReturnPopups(aThis, event);
			}, false);
			toolbarbutton_0.appendChild(menupopup_1);
			return toolbarbutton_0;
		}
	});

	CustomizableUI.createWidget({
		id: 'tb-edit-menu',
		label: buttonStrings.get('tb-edit-menu.label'),
		tooltiptext: buttonStrings.get('tb-edit-menu.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.showAMenu(event, 'menu_Edit', 'edit-menu');
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-options-menu',
		label: buttonStrings.get('tb-options-menu.label'),
		tooltiptext: buttonStrings.get('tb-options-menu.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.showAMenu(event, 'optionsMenu');
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-view-menu',
		label: buttonStrings.get('tb-view-menu.label'),
		tooltiptext: buttonStrings.get('tb-view-menu.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.showAMenu(event, 'menu_View', 'view-menu');
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-insert-menu',
		label: buttonStrings.get('tb-insert-menu.label'),
		tooltiptext: buttonStrings.get('tb-insert-menu.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.showAMenu(event, 'insertMenu');
		},
		toolbox: 'compose-toolbox'
	});
}

function loadButtons(window) {
	var document = window.document;
	var toolbox = document.getElementById('compose-toolbox');
	if(!toolbox) {
		return;
	}
	var extensionPrefs = Cc['@mozilla.org/preferences-service;1'].getService(Ci.nsIPrefService).getBranch("extension.tbutton.");
	
	registerToolbars(window, document, []);
	
	
	toolbar_buttons.allMenusStartUp(document);
}

function createToolbar(doc, toolbox, attributes, name) {
	var special = ["id", "class", "defaultset", "currentset"];
	var toolbar = doc.createElement('toolbar');
	for(var attr in attributes) {
		if(special.indexOf(attr) == -1) {
			toolbar.setAttribute(attr, attributes[attr]);
		}
	}
	toolbar.setAttribute('toolbarname', name);
	if(attributes.id) {
		toolbar.id = attributes.id;
	}
	if(attributes.class) {
		toolbar.className = attributes.class;
	}
	doc.getElementById(toolbox).appendChild(toolbar);
	// put after appending to stop Thunderbird/SeaMonkey loading the buttons
	// which messes with our CustomizableUI
	if(attributes.defaultset) {
		toolbar.setAttribute('defaultset', attributes['defaultset']);
	}
	if(attributes.currentset) {
		toolbar.setAttribute('currentset', attributes['currentset']);
	}
}

var gButtonIds = ["tb-help-menu", "tb-file-menu", "tb-format-menu", "tb-tools-menu", "tb-all-menus", "tb-edit-menu", "tb-options-menu", "tb-view-menu", "tb-insert-menu"];

function unloadButtons(window) {
	var document = window.document;
	var toolbarIds = [];
	var uiIds = ["tb-all-menus-panel-view"];

	for(var t = 0; t < toolbarIds.length; t++) {
		var toolbar = document.getElementById(toolbarIds[t]);
		if(toolbar) {
			CustomizableUI.unregisterArea(toolbarIds[t], false);
			toolbar.parentNode.removeChild(toolbar);
		}
	}
	for(var i = 0; i < gButtonIds.length; i++) {
		var buttonId = gButtonIds[i];
		var key = document.getElementById(buttonId + '-key');
		if(key) {
			key.parentNode.removeChild(key);
		}
		var menuitem = document.getElementById(buttonId + '-menu-item');
		if(menuitem) {
			menuitem.parentNode.removeChild(menuitem);
		}
	}
	var menu = document.getElementById('toolbar-buttons-menu');
	if(menu && !menu.firstChild.firstChild) {
		menu.parentNode.removeChild(menu);
	}
	for(var i = 0; i < uiIds.length; i++) {
		var node = document.getElementById(uiIds[i]);
		while(node) {
			node.parentNode.removeChild(node);
			node = document.getElementById(uiIds[i]);
		}
	}
	for(var i = 0; i < gShutDownFunctions.length; i++) {
		try {
			gShutDownFunctions[i]();
		} catch(e) {}
	}
}

function shutdownButtons() {
	log(gButtonIds);
	for(var i = 0; i < gButtonIds.length; i++) {
		CustomizableUI.destroyWidget(gButtonIds[i]);
	}
}

function registerToolbars(window, document, toolbar_ids) {
	for(var i in toolbar_ids) {
		observeToolbar(window, document, toolbar_ids[i]);
		CustomizableUI.registerArea(toolbar_ids[i], {
			type: CustomizableUI.TYPE_TOOLBAR,
			defaultPlacements: [],
			defaultCollapsed: false
		}, true);
	}
}

function observeToolbar(window, document, toolbar_id) {
	var prefs = Cc['@mozilla.org/preferences-service;1'].getService(Ci.nsIPrefService)
			.getBranch("extension.tbutton." + 'toolbar_status.' + toolbar_id + '.');
	var toolbar = document.getElementById(toolbar_id);
	var observer = function(mutations) {
		mutations.forEach(function(mutation) {
			if(mutation.attributeName && (CustomizableUI.shim || mutation.attributeName != 'currentset')) {
				prefs.setCharPref(mutation.attributeName, toolbar.getAttribute(mutation.attributeName));
			}
		});
	}
	var mutationObserver = new window.MutationObserver(observer);
	var attrList = prefs.getChildList('', {});
	for(var i in attrList) {
		toolbar.setAttribute(attrList[i], prefs.getCharPref(attrList[i]));
	}
	mutationObserver.observe(toolbar, { attributes: true, subtree: false });
}

function log(e) {
	Cc["@mozilla.org/consoleservice;1"].getService(Ci.nsIConsoleService).logStringMessage(e);
}